﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace GCSOLAR
{
    public partial class FormChangeParameters : Form
    {

        private bool buttonCancelWasClicked = false;
        private bool buttonSaveAndCloseWasClicked = false;

        /// <summary>
        /// Constructor.
        /// </summary>
        public FormChangeParameters()
        {
            InitializeComponent();

            this.ActiveControl = lblNameChemical;
            btnEditTable.Visible = true;
            DataTable table = new DataTable();
            DataTable tableLats = new DataTable();
            rbtnChemical.Checked = true;
            rbtnYes.Checked = true;
            rbtnONo.Checked = true;
            rbtnKlambdaNo.Checked = true;
            rbtnNoDP.Checked = true;
            Common.Listing(out table);
            Common.Latitudes(out tableLats);
            chkSpring.Checked = true;
            for (int i = 0; i < Common.iseasw; i++)
            {
                if (Common.sease[i].Equals("Spring"))
                {
                    chkSpring.Checked = true;
                }
                else if (Common.sease[i].Equals("Summer"))
                {
                    chkSummer.Checked = true;
                }
                else if (Common.sease[i].Equals("Fall"))
                {
                    chkFall.Checked = true;
                }
                else if (Common.sease[i].Equals("Winter"))
                {
                    chkWinter.Checked = true;
                }
            }

            cmbAbsorptions.Items.Add("Water Absorption Coefficients");
            cmbAbsorptions.Items.Add("Contaminant Absorption Coefficients");
            cmbAbsorptions.SelectedIndex = 0;

            this.dataGridView1.DataSource = table;
            this.dataGridView1.Visible = true;
            this.dataGridView2.DataSource = tableLats;
            this.dataGridView2.Visible = true;
            this.btnExportCSV.Visible = true;
            this.btnContaminant.Visible = true;

            lblRA.Visible = false;
            lblSD.Visible = false;
            lblST.Visible = false;
            lblLat.Visible = false;
            lblDegrees.Visible = false;
            lblMinutes.Visible = false;
            lblSeconds.Visible = false;
            lblDeltaz.Visible = false;

            textBox1.Visible = false;
            textBox2.Visible = false;
            textBox3.Visible = false;
            textBox4.Visible = false;
            textBox5.Visible = false;
            textBox6.Visible = false;
            textBox7.Visible = false;
            textBox8.Visible = false;
            textBox9.Visible = false;

            txtLat.Visible = false;
            txtDeltaz.Visible = false;

            // Set watermarks for each textbox
            txtName.ForeColor = Color.DarkGray;
            txtName.Text = Common.contaminantName;
            this.txtName.Leave += new System.EventHandler(this.txtName_Leave);
            this.txtName.Enter += new System.EventHandler(this.txtName_Enter);

            txtNumLats.ForeColor = Color.DarkGray;
            txtNumLats.Text = Common.ilatsw.ToString();
            this.txtNumLats.Leave += new System.EventHandler(this.txtNumLats_Leave);
            this.txtNumLats.Enter += new System.EventHandler(this.txtNumLats_Enter);

            txtLongitude.ForeColor = Color.DarkGray;
            txtLongitude.Text = Common.xlon.ToString("##.#");
            this.txtLongitude.Leave += new System.EventHandler(this.txtLongitude_Leave);
            this.txtLongitude.Enter += new System.EventHandler(this.txtLongitude_Enter);

            txtInitialDepth.ForeColor = Color.DarkGray;
            txtInitialDepth.Text = Common.dinit.ToString("0.###");
            this.txtInitialDepth.Leave += new System.EventHandler(this.txtInitialDepth_Leave);
            this.txtInitialDepth.Enter += new System.EventHandler(this.txtInitialDepth_Enter);

            txtFinalDepth.ForeColor = Color.DarkGray;
            txtFinalDepth.Text = Common.dfinal.ToString("###.#");
            this.txtFinalDepth.Leave += new System.EventHandler(this.txtFinalDepth_Leave);
            this.txtFinalDepth.Enter += new System.EventHandler(this.txtFinalDepth_Enter);

            txtDepthIncr.ForeColor = Color.DarkGray;
            txtDepthIncr.Text = Common.dinc.ToString("##.#");
            this.txtDepthIncr.Leave += new System.EventHandler(this.txtDepthIncr_Leave);
            this.txtDepthIncr.Enter += new System.EventHandler(this.txtDepthIncr_Enter);

            txtDeltaz.ForeColor = Color.DarkGray;
            txtDeltaz.Text = Common.deltaz.ToString("0.###");
            this.txtDeltaz.Leave += new System.EventHandler(this.txtDeltaz_Leave);
            this.txtDeltaz.Enter += new System.EventHandler(this.txtDeltaz_Enter);

            txtOzone.ForeColor = Color.DarkGray;
            txtOzone.Text = Common.aveozo.ToString("0.##");
            this.txtOzone.Leave += new System.EventHandler(this.txtOzone_Leave);
            this.txtOzone.Enter += new System.EventHandler(this.txtOzone_Enter);

            txtQY.ForeColor = Color.DarkGray;
            txtQY.Text = Common.q.ToString("0.##");
            this.txtQY.Leave += new System.EventHandler(this.txtQY_Leave);
            this.txtQY.Enter += new System.EventHandler(this.txtQY_Enter);

            txtElevation.ForeColor = Color.DarkGray;
            txtElevation.Text = Common.elevation.ToString("0.0");
            this.txtElevation.Leave += new System.EventHandler(this.txtElevation_Leave);
            this.txtElevation.Enter += new System.EventHandler(this.txtElevation_Enter);

            txtRefractive.ForeColor = Color.DarkGray;
            txtRefractive.Text = Common.musubr.ToString("#.##");
            this.txtRefractive.Leave += new System.EventHandler(this.txtRefractive_Leave);
            this.txtRefractive.Enter += new System.EventHandler(this.txtRefractive_Enter);

            textBox1.ForeColor = Color.DarkGray;
            textBox1.Text = Common.xx[0].ToString("##.###");
            this.textBox1.Leave += new System.EventHandler(this.textBox1_Leave);
            this.textBox1.Enter += new System.EventHandler(this.textBox1_Enter);

            textBox2.ForeColor = Color.DarkGray;
            textBox2.Text = Common.xx[1].ToString("##.###");
            this.textBox2.Leave += new System.EventHandler(this.textBox2_Leave);
            this.textBox2.Enter += new System.EventHandler(this.textBox2_Enter);

            textBox3.ForeColor = Color.DarkGray;
            textBox3.Text = Common.xx[2].ToString("##.###");
            this.textBox3.Leave += new System.EventHandler(this.textBox3_Leave);
            this.textBox3.Enter += new System.EventHandler(this.textBox3_Enter);

            textBox4.ForeColor = Color.DarkGray;
            textBox4.Text = Common.xx[3].ToString("##.###");
            this.textBox4.Leave += new System.EventHandler(this.textBox4_Leave);
            this.textBox4.Enter += new System.EventHandler(this.textBox4_Enter);

            textBox5.ForeColor = Color.DarkGray;
            textBox5.Text = Common.xx[4].ToString("##.###");
            this.textBox5.Leave += new System.EventHandler(this.textBox5_Leave);
            this.textBox5.Enter += new System.EventHandler(this.textBox5_Enter);

            textBox6.ForeColor = Color.DarkGray;
            textBox6.Text = Common.xx[5].ToString("##.###");
            this.textBox6.Leave += new System.EventHandler(this.textBox6_Leave);
            this.textBox6.Enter += new System.EventHandler(this.textBox6_Enter);

            textBox7.ForeColor = Color.DarkGray;
            textBox7.Text = Common.xx[6].ToString("##.###");
            this.textBox7.Leave += new System.EventHandler(this.textBox7_Leave);
            this.textBox7.Enter += new System.EventHandler(this.textBox7_Enter);

            textBox8.ForeColor = Color.DarkGray;
            textBox8.Text = Common.xx[7].ToString("##.###");
            this.textBox8.Leave += new System.EventHandler(this.textBox8_Leave);
            this.textBox8.Enter += new System.EventHandler(this.textBox8_Enter);

            textBox9.ForeColor = Color.DarkGray;
            textBox9.Text = Common.xx[8].ToString("##.###");
            this.textBox9.Leave += new System.EventHandler(this.textBox9_Leave);
            this.textBox9.Enter += new System.EventHandler(this.textBox9_Enter);

            txtLat.ForeColor = Color.DarkGray;
            txtLat.Text = Common.typlat.ToString();
            this.txtLat.Leave += new System.EventHandler(this.txtLat_Leave);
            this.txtLat.Enter += new System.EventHandler(this.txtLat_Enter);

        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtName_Leave(object sender, EventArgs e)
        {
            if (txtName.Text.Trim() == "")
            {
                txtName.Text = Common.contaminantName;
                txtName.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtName_Enter(object sender, EventArgs e)
        {
            if (txtName.Text == Common.contaminantName)
            {
                txtName.Text = "";
                txtName.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtNumLats_Leave(object sender, EventArgs e)
        {
            if (txtNumLats.Text == "")
            {
                txtNumLats.Text = Common.ilatsw.ToString();
                txtNumLats.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtNumLats_Enter(object sender, EventArgs e)
        {
            if (txtNumLats.Text == Common.ilatsw.ToString())
            {
                txtNumLats.Text = "";
                txtNumLats.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtLongitude_Leave(object sender, EventArgs e)
        {
            if (txtLongitude.Text == "")
            {
                txtLongitude.Text = Common.xlon.ToString("##.#");
                txtLongitude.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtLongitude_Enter(object sender, EventArgs e)
        {
            if (txtLongitude.Text == Common.xlon.ToString("##.#"))
            {
                txtLongitude.Text = "";
                txtLongitude.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtInitialDepth_Leave(object sender, EventArgs e)
        {
            if (txtInitialDepth.Text == "")
            {
                txtInitialDepth.Text = Common.dinit.ToString("0.###");
                txtInitialDepth.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtInitialDepth_Enter(object sender, EventArgs e)
        {
            if (txtInitialDepth.Text == Common.dinit.ToString("0.###"))
            {
                txtInitialDepth.Text = "";
                txtInitialDepth.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtFinalDepth_Leave(object sender, EventArgs e)
        {
            if (txtFinalDepth.Text == "")
            {
                txtFinalDepth.Text = Common.dfinal.ToString("###.#");
                txtFinalDepth.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtFinalDepth_Enter(object sender, EventArgs e)
        {
            if (txtFinalDepth.Text == Common.dfinal.ToString("###.#"))
            {
                txtFinalDepth.Text = "";
                txtFinalDepth.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtDepthIncr_Leave(object sender, EventArgs e)
        {
            if (txtDepthIncr.Text == "")
            {
                txtDepthIncr.Text = Common.dinc.ToString("##.#");
                txtDepthIncr.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtDepthIncr_Enter(object sender, EventArgs e)
        {
            if (txtDepthIncr.Text == Common.dinc.ToString("##.#"))
            {
                txtDepthIncr.Text = "";
                txtDepthIncr.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtDeltaz_Leave(object sender, EventArgs e)
        {
            if (txtDeltaz.Text == "")
            {
                txtDeltaz.Text = Common.deltaz.ToString("0.###");
                txtDeltaz.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtDeltaz_Enter(object sender, EventArgs e)
        {
            if (txtDeltaz.Text == Common.deltaz.ToString("0.###"))
            {
                txtDeltaz.Text = "";
                txtDeltaz.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtOzone_Leave(object sender, EventArgs e)
        {
            if (txtOzone.Text == "")
            {
                txtOzone.Text = Common.aveozo.ToString("0.##");
                txtOzone.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtOzone_Enter(object sender, EventArgs e)
        {
            if (txtOzone.Text == Common.aveozo.ToString("0.##"))
            {
                txtOzone.Text = "";
                txtOzone.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtQY_Leave(object sender, EventArgs e)
        {
            if (txtQY.Text == "")
            {
                txtQY.Text = Common.q.ToString("0.##");
                txtQY.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtQY_Enter(object sender, EventArgs e)
        {
            if (txtQY.Text == Common.q.ToString("0.##"))
            {
                txtQY.Text = "";
                txtQY.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtElevation_Leave(object sender, EventArgs e)
        {
            if (txtElevation.Text == "")
            {
                txtElevation.Text = Common.elevation.ToString("0.0");
                txtElevation.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtElevation_Enter(object sender, EventArgs e)
        {
            if (txtElevation.Text == Common.elevation.ToString("0.0"))
            {
                txtElevation.Text = "";
                txtElevation.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtRefractive_Leave(object sender, EventArgs e)
        {
            if (txtRefractive.Text == "")
            {
                txtRefractive.Text = Common.musubr.ToString("#.##");
                txtRefractive.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtRefractive_Enter(object sender, EventArgs e)
        {
            if (txtRefractive.Text == Common.musubr.ToString("#.##"))
            {
                txtRefractive.Text = "";
                txtRefractive.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_Leave(object sender, EventArgs e)
        {
            if (textBox1.Text == "")
            {
                textBox1.Text = Common.xx[0].ToString("##.###");
                textBox1.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_Enter(object sender, EventArgs e)
        {
            if (textBox1.Text == Common.xx[0].ToString("##.###"))
            {
                textBox1.Text = "";
                textBox1.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox2_Leave(object sender, EventArgs e)
        {
            if (textBox2.Text == "")
            {
                textBox2.Text = Common.xx[1].ToString("##.###");
                textBox2.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox2_Enter(object sender, EventArgs e)
        {
            if (textBox2.Text == Common.xx[1].ToString("##.###"))
            {
                textBox2.Text = "";
                textBox2.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox3_Leave(object sender, EventArgs e)
        {
            if (textBox3.Text == "")
            {
                textBox3.Text = Common.xx[2].ToString("##.###");
                textBox3.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox3_Enter(object sender, EventArgs e)
        {
            if (textBox3.Text == Common.xx[2].ToString("##.###"))
            {
                textBox3.Text = "";
                textBox3.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox4_Leave(object sender, EventArgs e)
        {
            if (textBox4.Text == "")
            {
                textBox4.Text = Common.xx[3].ToString("##.###");
                textBox4.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox4_Enter(object sender, EventArgs e)
        {
            if (textBox4.Text == Common.xx[3].ToString("##.###"))
            {
                textBox4.Text = "";
                textBox4.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox5_Leave(object sender, EventArgs e)
        {
            if (textBox5.Text == "")
            {
                textBox5.Text = Common.xx[4].ToString("##.###");
                textBox5.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox5_Enter(object sender, EventArgs e)
        {
            if (textBox5.Text == Common.xx[4].ToString("##.###"))
            {
                textBox5.Text = "";
                textBox5.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox6_Leave(object sender, EventArgs e)
        {
            if (textBox6.Text == "")
            {
                textBox6.Text = Common.xx[5].ToString("##.###");
                textBox6.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox6_Enter(object sender, EventArgs e)
        {
            if (textBox6.Text == Common.xx[5].ToString("##.###"))
            {
                textBox6.Text = "";
                textBox6.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox7_Leave(object sender, EventArgs e)
        {
            if (textBox7.Text == "")
            {
                textBox7.Text = Common.xx[6].ToString("##.###");
                textBox7.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox7_Enter(object sender, EventArgs e)
        {
            if (textBox7.Text == Common.xx[6].ToString("##.###"))
            {
                textBox7.Text = "";
                textBox7.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox8_Leave(object sender, EventArgs e)
        {
            if (textBox8.Text == "")
            {
                textBox8.Text = Common.xx[7].ToString("##.###");
                textBox8.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox8_Enter(object sender, EventArgs e)
        {
            if (textBox8.Text == Common.xx[7].ToString("##.###"))
            {
                textBox8.Text = "";
                textBox8.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox9_Leave(object sender, EventArgs e)
        {
            if (textBox9.Text == "")
            {
                textBox9.Text = Common.xx[8].ToString("##.###");
                textBox9.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox9_Enter(object sender, EventArgs e)
        {
            if (textBox9.Text == Common.xx[8].ToString("##.###"))
            {
                textBox9.Text = "";
                textBox9.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event sets the text in the textbox to a stored value in the program whenever
        /// the user leaves the textbox (user places the cursor somewhere else) without 
        /// entering anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtLat_Leave(object sender, EventArgs e)
        {
            if (txtLat.Text == "")
            {
                txtLat.Text = Common.typlat.ToString();
                txtLat.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This event removes the text in the textbox whenever the user places the cursor in it.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtLat_Enter(object sender, EventArgs e)
        {
            if (txtLat.Text == Common.typlat.ToString())
            {
                txtLat.Text = "";
                txtLat.ForeColor = Color.Black;
            }
        }

        /// <summary>
        /// This method exits the form without saving anything.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnCancel_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Exiting without saving any new changes.");
            buttonCancelWasClicked = true;
            this.Close();
        }

        private void update_Values()
        {
            string strName = txtName.Text.Trim();
            string strLongitude = txtLongitude.Text.Trim();
            string strQ = txtQY.Text.Trim();
            string strDeltaz = txtDeltaz.Text.Trim();
            string strElevation = txtElevation.Text.Trim();
            string strInitDepth = txtInitialDepth.Text.Trim();
            string strFinalDepth = txtFinalDepth.Text.Trim();
            string strDepthIncr = txtDepthIncr.Text.Trim();
            string strRefractive = txtRefractive.Text.Trim();
            string strOzone;
            bool defaultOzone;
            bool performDepthPoint;

            if (rbtnYesDP.Checked == true)
            {
                performDepthPoint = true;
            }
            else
            {
                performDepthPoint = false;
            }

            if (rbtnYes.Checked == true)
            {
                int numSeasons = -1;
                if (chkSpring.Checked == true)
                {
                    numSeasons++;
                    Common.sease[numSeasons] = "Spring";
                }
                if (chkSummer.Checked == true)
                {
                    numSeasons++;
                    Common.sease[numSeasons] = "Summer";
                }
                if (chkFall.Checked == true)
                {
                    numSeasons++;
                    Common.sease[numSeasons] = "Fall";
                }
                if (chkWinter.Checked == true)
                {
                    numSeasons++;
                    Common.sease[numSeasons] = "Winter";
                }
                Common.iseasw = numSeasons + 1;

                if (rbtnOYes.Checked == true)
                {
                    defaultOzone = true;
                    strOzone = "";
                }
                else
                {
                    defaultOzone = false;
                    strOzone = txtOzone.Text.Trim();
                }
                Common.ProcessInputData(strName, strLongitude, defaultOzone, strOzone,
                                        strQ, performDepthPoint, strDeltaz, strElevation,
                                        strInitDepth, strFinalDepth, strDepthIncr, strRefractive);
            }

            if (rbtnNo.Checked == true)
            {
                strOzone = txtOzone.Text.Trim();
                string t1 = textBox1.Text.Trim();
                string t2 = textBox2.Text.Trim();
                string t3 = textBox3.Text.Trim();
                string t4 = textBox4.Text.Trim();
                string t5 = textBox5.Text.Trim();
                string t6 = textBox6.Text.Trim();
                string t7 = textBox7.Text.Trim();
                string t8 = textBox8.Text.Trim();
                string t9 = textBox9.Text.Trim();
                string lat = txtLat.Text.Trim();
                Common.ProcessInputData(strName, strLongitude, strOzone,
                                        strQ, performDepthPoint, strDeltaz, strElevation,
                                        strInitDepth, strFinalDepth, strDepthIncr, strRefractive,
                                        t1, t2, t3, t4, t5, t6, t7, t8, t9, lat);
            }

            MessageBox.Show("Parameters were successfully updated.");
        }


        /// <summary>
        /// This method handles the input of latitudes into the program.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnLatitudes_Click(object sender, EventArgs e)
        {
            string errorMessage;

            if (!ValidNumLats(txtNumLats.Text, out errorMessage))
            {
                errorProvider1.SetError(txtNumLats, errorMessage);
                return;
            }

            int numlats = Convert.ToInt32(txtNumLats.Text.Trim());

            Latitudes lat = new Latitudes();
            if (lat.InputLatitudes(numlats) == DialogResult.OK)
            {
                MessageBox.Show("Latitudes were successfully entered.");
                DataTable dt = new DataTable();
                DataRow dr1 = null;
                dt.Columns.Add("Latitude index");
                dt.Columns.Add("Latitude");

                for (int i = 0; i < Common.ilatsw; i++)
                {
                    dr1 = dt.NewRow();
                    dr1["Latitude index"] = i + 1;
                    dr1["Latitude"] = Common.ilattm[i];
                    dt.Rows.Add(dr1);
                }

                dataGridView2.DataSource = dt;
                dataGridView2.Visible = true;
            }
        }

        /// <summary>
        /// This method closes the current form.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClose_Click(object sender, EventArgs e)
        {
            if (!ValidateFields())
            {
                MessageBox.Show("There are invalid entries: check the textboxes marked with an exclamation point!  Otherwise click Cancel to exit without saving any changes.");
                return;
            }

            update_Values();
            buttonSaveAndCloseWasClicked = true;

            this.Close();
        }

        /// <summary>
        /// This method allows the user to edit the wavelengths and absorption 
        /// coefficients.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEditTable_Click(object sender, EventArgs e)
        {

            if (rbtnChemical.Checked)
            {
                Common.contaminantType = "Chemical";
                Common.contaminantUnits = "Absorption Coefficients (L/(mole cm))";
            }
            if (rbtnBiological.Checked)
            {
                Common.contaminantType = "Biological";
                Common.contaminantUnits = "Weighting Function (hr^(-1) Watts^(-1) cm^2 nm)";
            }

            FormEnterWaveLengths formEnterWavelengths = new FormEnterWaveLengths();
            formEnterWavelengths.ShowDialog();

            DataTable dt = new DataTable();
            Common.Listing(out dt);
            this.dataGridView1.DataSource = dt;

        }

        /// <summary>
        /// This is the main validation method which calls other methods that will validate 
        /// the GUI's input parameters.
        /// </summary>
        /// <returns></returns>
        private bool ValidateFields()
        {
            bool ok = true;
            string errorMessage;

            if (!ValidName(txtName.Text, out errorMessage))
            {
                errorProvider1.SetError(txtName, errorMessage);
                ok = false;
            }

            if (rbtnYes.Checked == true)
            {
                if (!ValidNumLats(txtNumLats.Text, out errorMessage))
                {
                    errorProvider1.SetError(txtNumLats, errorMessage);
                    ok = false;
                }
            }
            

            if (!ValidLongitude(txtLongitude.Text, out errorMessage))
            {
                errorProvider1.SetError(txtLongitude, errorMessage);
                ok = false;
            }

            if (!ValidInitialDepth(txtInitialDepth.Text, out errorMessage))
            {
                errorProvider1.SetError(txtInitialDepth, errorMessage);
                ok = false;
            }

            if (!ValidFinalDepth(txtFinalDepth.Text, out errorMessage))
            {
                errorProvider1.SetError(txtFinalDepth, errorMessage);
                ok = false;
            }

            if (!ValidDepthIncr(txtDepthIncr.Text, out errorMessage))
            {
                errorProvider1.SetError(txtDepthIncr, errorMessage);
                ok = false;
            }

            if (rbtnYesDP.Checked == true)
            {
                if (!ValidDeltaz(txtDeltaz.Text, out errorMessage))
                {
                    errorProvider1.SetError(txtDeltaz, errorMessage);
                    ok = false;
                }
            }
            
            if (rbtnONo.Checked == true)
            {
                if (!ValidOzone(txtOzone.Text, out errorMessage))
                {
                    errorProvider1.SetError(txtOzone, errorMessage);
                    ok = false;
                }
            }
            

            if (!ValidQY(txtQY.Text, out errorMessage))
            {
                errorProvider1.SetError(txtQY, errorMessage);
                ok = false;
            }

            if (!ValidElevation(txtElevation.Text, out errorMessage))
            {
                errorProvider1.SetError(txtElevation, errorMessage);
                ok = false;
            }

            if (!ValidRefractive(txtRefractive.Text, out errorMessage))
            {
                errorProvider1.SetError(txtRefractive, errorMessage);
                ok = false;
            }

            if (rbtnYes.Checked == true)
            {
                if (!ValidSeasons(out errorMessage))
                {
                    errorProvider1.SetError(gbtnSeasons, errorMessage);
                    ok = false;
                }
            }

            if (rbtnNo.Checked == true)
            {
                if (!ValidDegrees(textBox1.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox1, errorMessage);
                    ok = false;
                }

                if (!ValidMinutes(textBox2.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox2, errorMessage);
                    ok = false;
                }

                if (!ValidSeconds(textBox3.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox3, errorMessage);
                    ok = false;
                }

                if (!ValidDegrees(textBox4.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox4, errorMessage);
                    ok = false;
                }

                if (!ValidMinutes(textBox5.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox5, errorMessage);
                    ok = false;
                }

                if (!ValidSeconds(textBox6.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox6, errorMessage);
                    ok = false;
                }

                if (!ValidDegrees(textBox7.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox7, errorMessage);
                    ok = false;
                }

                if (!ValidMinutes(textBox8.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox8, errorMessage);
                    ok = false;
                }

                if (!ValidSeconds(textBox9.Text, out errorMessage))
                {
                    errorProvider1.SetError(textBox9, errorMessage);
                    ok = false;
                }

                if (!ValidLatitude(txtLat.Text, out errorMessage))
                {
                    errorProvider1.SetError(txtLat, errorMessage);
                    ok = false;
                }
            }

            return ok;
        }

        /// <summary>
        /// This method validates the entry for the contaminant's name.
        /// </summary>
        /// <param name="txtName"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidName(string txtName, out string errorMessage)
        {
            if (string.IsNullOrEmpty(txtName))
            {
                errorMessage = "The name of the chemical is required.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for the number of latitudes.
        /// </summary>
        /// <param name="txtNumLats"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidNumLats(string txtNumLats, out string errorMessage)
        {
            int numlats;

            if (string.IsNullOrEmpty(txtNumLats))
            {
                errorMessage = "Number of latitudes is required.";
                return false;
            }

            if (txtNumLats.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Int32.TryParse(txtNumLats, out numlats))
            {
                errorMessage = "Number of Latitudes must be an integer.";
                return false;
            }

            if (numlats < 1 || numlats > 10)
            {
                errorMessage = "Number of latitudes must be a number between 1 and 10";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for longitude.
        /// </summary>
        /// <param name="txtLongitude"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidLongitude(string txtLongitude, out string errorMessage)
        {
            double longitude;

            if (string.IsNullOrEmpty(txtLongitude))
            {
                errorMessage = "Longitude is required.";
                return false;
            }

            if (txtLongitude.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtLongitude, out longitude))
            {
                errorMessage = "Longitude must be a real number.";
                return false;
            }

            if (longitude < -180.0 || longitude > 180.0)
            {
                errorMessage = "Longitude must be a number between -180 and 180.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for initial depth in body of water.
        /// </summary>
        /// <param name="txtInitialDepth"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidInitialDepth(string txtInitialDepth, out string errorMessage)
        {
            double initialDepth;

            if (string.IsNullOrEmpty(txtInitialDepth))
            {
                errorMessage = "Initial depth is required.";
                return false;
            }

            if (txtInitialDepth.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtInitialDepth, out initialDepth))
            {
                errorMessage = "Initial depth must be a real number.";
                return false;
            }

            if (initialDepth < 0.0 || initialDepth > 100.0)
            {
                errorMessage = "Initial depth must be a number between 0 and 100cm.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for final depth in body of water.
        /// </summary>
        /// <param name="txtFinalDepth"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidFinalDepth(string txtFinalDepth, out string errorMessage)
        {
            double finalDepth;

            if (string.IsNullOrEmpty(txtFinalDepth))
            {
                errorMessage = "Final depth is required.";
                return false;
            }

            if (txtFinalDepth.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtFinalDepth, out finalDepth))
            {
                errorMessage = "Final depth must be a real number.";
                return false;
            }

            if (finalDepth < 0.0)
            {
                errorMessage = "Final depth must be a number greater than 0.0cm.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for depth increment in body of water.
        /// </summary>
        /// <param name="txtDepthIncr"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidDepthIncr(string txtDepthIncr, out string errorMessage)
        {
            double depthIncr;

            if (string.IsNullOrEmpty(txtDepthIncr))
            {
                errorMessage = "Depth increment is required.";
                return false;
            }

            if (txtDepthIncr.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtDepthIncr, out depthIncr))
            {
                errorMessage = "Depth increment must be a real number.";
                return false;
            }

            if (depthIncr < 0.0)
            {
                errorMessage = "Depth increment must be a number greater than 0.0cm.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for the depth point in body of water.
        /// </summary>
        /// <param name="txtDeltaz"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidDeltaz(string txtDeltaz, out string errorMessage)
        {
            double deltaz;

            if (string.IsNullOrEmpty(txtDeltaz))
            {
                errorMessage = "Depth point is required.";
                return false;
            }

            if (txtDeltaz.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtDeltaz, out deltaz))
            {
                errorMessage = "Depth point must be a real number.";
                return false;
            }

            if (deltaz <= 0.0 || deltaz >= 0.05)
            {
                errorMessage = "Depth point must be a number between 0.0 and 0.05 cm.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for the ozone layer thickness.
        /// </summary>
        /// <param name="txtOzone"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidOzone(string txtOzone, out string errorMessage)
        {
            double ozone;

            if (string.IsNullOrEmpty(txtOzone))
            {
                errorMessage = "Ozone is required.";
                return false;
            }

            if (txtOzone.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtOzone, out ozone))
            {
                errorMessage = "Ozone is not double.";
                return false;
            }

            if (ozone < 0.0)
            {
                errorMessage = "The atmospheric ozone layer must be greater than zero.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for the contaminant's quantum yield.
        /// </summary>
        /// <param name="txtQY"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidQY(string txtQY, out string errorMessage)
        {
            double qy;

            if (string.IsNullOrEmpty(txtQY))
            {
                errorMessage = "Quantum yield is required.";
                return false;
            }

            if (txtQY.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtQY, out qy))
            {
                errorMessage = "Quantum yield is not double.";
                return false;
            }

            if (qy < 0.0 || qy > 4.0)
            {
                errorMessage = "Quantum Yield is a number between 0 and 4.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for elevation.
        /// </summary>
        /// <param name="txtElevation"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidElevation(string txtElevation, out string errorMessage)
        {
            double elevation;

            if (string.IsNullOrEmpty(txtElevation))
            {
                errorMessage = "Elevation is required.";
                return false;
            }

            if (txtElevation.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtElevation, out elevation))
            {
                errorMessage = "Elevation is not double.";
                return false;
            }

            if (elevation < 0.0 || elevation > 100.0)
            {
                errorMessage = "Elevation is a number between 0 and 100km.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for the refractive index of the body of water.
        /// </summary>
        /// <param name="txtRefractive"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidRefractive(string txtRefractive, out string errorMessage)
        {
            double refractive;

            if (string.IsNullOrEmpty(txtRefractive))
            {
                errorMessage = "Refraction index is required.";
                return false;
            }

            if (txtRefractive.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtRefractive, out refractive))
            {
                errorMessage = "Refraction index is not double.";
                return false;
            }

            if (refractive < 1.0 || refractive > 4.0)
            {
                errorMessage = "Refraction index is a number between 1 and 4.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        /// <summary>
        /// This method validates the entry for the degrees of solar declination, right ascension,
        /// and sidereal time.
        /// </summary>
        /// <param name="txtdegrees"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidDegrees(string txtdegrees, out string errorMessage)
        {
            double degrees;
            if (string.IsNullOrEmpty(txtdegrees))
            {
                errorMessage = "Degrees are required.";
                return false;
            }

            if (txtdegrees.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtdegrees, out degrees))
            {
                errorMessage = "Degrees is not a real number.";
                return false;
            }

            if (degrees < 0.0 || degrees > 90.0)
            {
                errorMessage = "Degrees must be a real number between 0 and 90.";
                return false;
            }
            else
            {
                errorMessage = "";
                return true;
            }
        }

        /// <summary>
        /// This method validates the entry for the minutes of solar declination, right ascension,
        /// and sidereal time.
        /// </summary>
        /// <param name="txtminutes"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidMinutes(string txtminutes, out string errorMessage)
        {
            double minutes;
            if (string.IsNullOrEmpty(txtminutes))
            {
                errorMessage = "Minutes are required.";
                return false;
            }

            if (txtminutes.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtminutes, out minutes))
            {
                errorMessage = "Minutes is not a real number.";
                return false;
            }

            if (minutes < 0.0 || minutes > 60.0)
            {
                errorMessage = "Minutes must be a real number between 0 and 60.";
                return false;
            }
            else
            {
                errorMessage = "";
                return true;
            }
        }

        /// <summary>
        /// This method validates the entry for the seconds of solar declination, right ascension,
        /// and sidereal time.
        /// </summary>
        /// <param name="txtseconds"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidSeconds(string txtseconds, out string errorMessage)
        {
            double seconds;
            if (string.IsNullOrEmpty(txtseconds))
            {
                errorMessage = "Seconds are required.";
                return false;
            }

            if (txtseconds.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtseconds, out seconds))
            {
                errorMessage = "Seconds is not a real number.";
                return false;
            }

            if (seconds < 0.0 || seconds > 60.0)
            {
                errorMessage = "Seconds must be a real number between 0 and 60.";
                return false;
            }
            else
            {
                errorMessage = "";
                return true;
            }
        }

        /// <summary>
        /// This method validates the entry for latitude.
        /// </summary>
        /// <param name="txtlatitude"></param>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidLatitude(string txtlatitude, out string errorMessage)
        {
            double latitude;
            if (string.IsNullOrEmpty(txtlatitude))
            {
                errorMessage = "Latitude is required.";
                return false;
            }

            if (txtlatitude.Contains(" "))
            {
                errorMessage = "Do not enter spaces.";
                return false;
            }

            if (!Double.TryParse(txtlatitude, out latitude))
            {
                errorMessage = "Latitude is not a decimal value.";
                return false;
            }

            if (latitude < 0.0 || latitude > 90.0)
            {
                errorMessage = "Latitude must be a number between 0 and 90.";
                return false;
            }
            else
            {
                errorMessage = "";
                return true;
            }
        }

        /// <summary>
        /// This method checks whether the user selected at least one season.
        /// </summary>
        /// <param name="errorMessage"></param>
        /// <returns></returns>
        private bool ValidSeasons(out string errorMessage)
        {
            if (chkFall.Checked == false && chkSpring.Checked == false && 
                chkSummer.Checked == false && chkWinter.Checked == false)
            {
                errorMessage = "User must select at least one season.";
                return false;
            }

            errorMessage = "";
            return true;
        }

        private void txtName_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtName, "");
        }

        private void txtName_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidName(txtName.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtName, errorMessage);
            }
        }

        private void txtNumLats_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtNumLats, "");
        }

        private void txtNumLats_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidNumLats(txtNumLats.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtNumLats, errorMessage);
            }
        }

        private void txtLongitude_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtLongitude, "");
        }

        private void txtLongitude_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidLongitude(txtLongitude.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtLongitude, errorMessage);
            }
        }

        private void txtInitialDepth_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtInitialDepth, "");
        }

        private void txtInitialDepth_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidInitialDepth(txtInitialDepth.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtInitialDepth, errorMessage);
            }
        }

        private void txtFinalDepth_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtFinalDepth, "");
        }

        private void txtFinalDepth_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidFinalDepth(txtFinalDepth.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtFinalDepth, errorMessage);
            }
        }

        private void txtDepthIncr_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtDepthIncr, "");
        }

        private void txtDepthIncr_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidDepthIncr(txtDepthIncr.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtDepthIncr, errorMessage);
            }
        }

        private void txtDeltaz_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtDeltaz, "");
        }

        private void txtDeltaz_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidDeltaz(txtDeltaz.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtDeltaz, errorMessage);
            }
        }

        private void txtOzone_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtOzone, "");
        }

        private void txtOzone_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidOzone(txtOzone.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtOzone, errorMessage);
            }
        }

        private void txtQY_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtQY, "");
        }

        private void txtQY_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidQY(txtQY.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtQY, errorMessage);
            }
        }

        private void txtElevation_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtElevation, "");
        }

        private void txtElevation_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidElevation(txtElevation.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtElevation, errorMessage);
            }
        }

        private void txtRefractive_Validated(object sender, EventArgs e)
        {
            // If all conditions have been met, clear the ErrorProvider of errors.
            errorProvider1.SetError(txtRefractive, "");
        }

        private void txtRefractive_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidRefractive(txtRefractive.Text, out errorMessage))
            {
                // Cancel the event and select the text to be corrected by the user.
                e.Cancel = true;

                // Set the ErrorProvider error with the text to display. 
                this.errorProvider1.SetError(txtRefractive, errorMessage);
            }
        }


        private void btnExportCSV_Click(object sender, EventArgs e)
        {
            Utility.ExportColumnDataFile(this.dataGridView1, 2);
        }

        /// <summary>
        /// This method resets all input parameters to their default values.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRestore_Click(object sender, EventArgs e)
        {
            // Reset variables associated with the textboxes.
            Common.contaminantName = "Methoxyclor";
            Common.minwav = 8;
            Common.maxwav = 19;
            Common.xlon = 83.2;
            Common.q = 0.32;
            Common.deltaz = 0.001;
            Common.elevation = 0.0;
            Common.dinc = 10.0;
            Common.dfinal = 5.0;
            Common.dinit = 0.001;
            Common.musubr = 1.34;
            Common.aveozo = 0.30;
            Common.ilatsw = 1;
            Common.iseasw = 1;
            Common.sease[0] = "Spring";
            Common.sease[1] = " ";
            Common.sease[2] = " ";
            Common.sease[3] = " ";

            // Reset the latitudes array.
            for (int i = 0; i < Common.ilattm.Length; i++)
            {
                if (i == 0) 
                {
                    Common.ilattm[i] = 40.0;
                }
                else
                {
                    Common.ilattm[i] = -99.0;
                }
            }

            // Contaminant absorptions
            double[] molarAbs = new double[46] { 2200.0, 2020.0, 1530.0, 642.0, 271.0, 102.0, 28.0,  
                                                 11.1, 4.67, 1.9, 1.1, 0.8, 0.53, 0.33, 0.27, 0.16, 
                                                 0.1, 0.06, 0.02, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                                 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                                 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                                 0.0, 0.0, 0.0 };

            // Water absorptions
            double[] waterAbs = new double[46] { 0.00120, 0.00113, 0.00106, 0.00099, 0.00093, 0.00085,
                                                 0.00077, 0.00069, 0.00061, 0.00057, 0.00053, 0.00049, 
                                                 0.00045, 0.00043, 0.00041, 0.00039, 0.00037, 0.00035,   
                                                 0.00029, 0.00024, 0.00020, 0.00016, 0.00013, .000096,  
                                                 0.000083, 0.000074, 0.000070, 0.000066, 0.000062, 0.000062,   
                                                 0.000062, 0.000068, 0.000068, 0.000076, 0.000085, 0.00012, 
                                                 0.00021, 0.00028, 0.00041, 0.00100, 0.00140, 0.00150,  
                                                 0.00190, 0.00280, 0.01000, 0.00890 };

            // Reset the contaminant and water absorptions arrays.
            for (int i = 0; i < molarAbs.Length; i++)
            {
                Common.setEppest(molarAbs[i], i);
                Common.setAbwat(waterAbs[i], i);
            }

            // Reset the values of the textboxes (they show up as watermarks).
            txtName.Text = Common.contaminantName;
            txtLongitude.Text = Common.xlon.ToString();
            txtDepthIncr.Text = Common.dinc.ToString();
            txtDeltaz.Text = Common.deltaz.ToString();
            txtElevation.Text = Common.elevation.ToString("0.0");
            txtFinalDepth.Text = Common.dfinal.ToString();
            txtInitialDepth.Text = Common.dinit.ToString();
            txtNumLats.Text = Common.ilatsw.ToString();
            txtOzone.Text = Common.aveozo.ToString();
            txtQY.Text = Common.q.ToString();
            txtRefractive.Text = Common.musubr.ToString();

            // Reset the checkboxes for the seasons.
            chkFall.Checked = false;
            chkSpring.Checked = true;
            chkSummer.Checked = false;
            chkWinter.Checked = false;

            // Reset radio buttons.
            rbtnChemical.Checked = true;
            rbtnYes.Checked = true;
            rbtnONo.Checked = true;
            rbtnKlambdaNo.Checked = true;

            // Reset combo boxes.
            cmbAbsorptions.SelectedIndex = 0;

            // Reset site-specific ephemeride values: array and textboxes.
            Common.xx[0] = 23.0;
            Common.xx[1] = 26.0;
            Common.xx[2] = 24.1;
            Common.xx[3] = 5.0;
            Common.xx[4] = 58.0;
            Common.xx[5] = 53.26;
            Common.xx[6] = 17.0;
            Common.xx[7] = 57.0;
            Common.xx[8] = 16.047;

            textBox1.Text = Common.xx[0].ToString();
            textBox2.Text = Common.xx[1].ToString();
            textBox3.Text = Common.xx[2].ToString();
            textBox4.Text = Common.xx[3].ToString();
            textBox5.Text = Common.xx[4].ToString();
            textBox6.Text = Common.xx[5].ToString();
            textBox7.Text = Common.xx[6].ToString();
            textBox8.Text = Common.xx[7].ToString();
            textBox9.Text = Common.xx[8].ToString();

            // Reset the absorptions table (Table 1)
            DataTable dt = new DataTable();
            Common.Listing(out dt);
            dataGridView1.DataSource = dt;

            // Reset the latitudes table.
            DataTable dtlat = new DataTable();
            Common.Latitudes(out dtlat);
            dataGridView2.DataSource = dtlat;

            // Display message to the user.
            MessageBox.Show("Input parameters were successfully set to their default values.");

        }

        /// <summary>
        /// This method handles the exporting of contaminant data to file.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnContaminat_Click(object sender, EventArgs e)
        {
            Utility.ExportColumnDataFile(dataGridView1, 1);
        }

        /// <summary>
        /// This method handles the exporting of all data to file.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnExportAll_Click(object sender, EventArgs e)
        {
            Utility.ExportTextBasedFile(dataGridView1);
        }

        /// <summary>
        /// This method checks whether the chemical-option radio button has been checked.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rbtnChemical_CheckedChanged(object sender, EventArgs e)
        {
            Common.contaminantType = "Chemical";
            Common.contaminantUnits = "Absorption Coefficients (L/(mole cm))";
            DataTable dt = new DataTable();
            Common.Listing(out dt);
            dataGridView1.DataSource = dt;
        }

        // <summary>
        /// This method checks whether the biological-option radio button has been checked.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rbtnBiological_CheckedChanged(object sender, EventArgs e)
        {
            Common.contaminantType = "Biological";
            Common.contaminantUnits = "Weighting Function (hr^(-1) Watts^(-1) cm^2 nm)";
            DataTable dt = new DataTable();
            Common.Listing(out dt);
            dataGridView1.DataSource = dt;
        }

        /// <summary>
        /// This method checks whether the user has selected to use typical ephemeride values.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rbtnYes_CheckedChanged(object sender, EventArgs e)
        {
            lblRA.Visible = false;
            lblSD.Visible = false;
            lblST.Visible = false;
            lblDegrees.Visible = false;
            lblMinutes.Visible = false;
            lblSeconds.Visible = false;
            lblNumLats.Visible = true;
            txtNumLats.Visible = true;
            btnLatitudes.Visible = true;
            dataGridView2.Visible = true;
            gbtnSeasons.Visible = true;
            chkFall.Visible = true;
            chkSpring.Visible = true;
            chkSummer.Visible = true;
            chkWinter.Visible = true;
            lblLat.Visible = false;
            txtLat.Visible = false;

            textBox1.Visible = false;
            textBox2.Visible = false;
            textBox3.Visible = false;
            textBox4.Visible = false;
            textBox5.Visible = false;
            textBox6.Visible = false;
            textBox7.Visible = false;
            textBox8.Visible = false;
            textBox9.Visible = false;

            rbtnOYes.Enabled = true;

            Common.ityp = 0;

        }

        /// <summary>
        /// This method checks whether the user has selected to use non-typical ephemeride values.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rbtnNo_CheckedChanged(object sender, EventArgs e)
        {
            lblRA.Visible = true;
            lblSD.Visible = true;
            lblST.Visible = true;
            lblDegrees.Visible = true;
            lblMinutes.Visible = true;
            lblSeconds.Visible = true;
            lblLat.Visible = true;
            lblNumLats.Visible = false;
            txtNumLats.Visible = false;
            btnLatitudes.Visible = false;
            dataGridView2.Visible = false;
            gbtnSeasons.Visible = false;
            chkFall.Visible = false;
            chkSpring.Visible = false;
            chkSummer.Visible = false;
            chkWinter.Visible = false;
            txtLat.Visible = true;

            textBox1.Visible = true;
            textBox2.Visible = true;
            textBox3.Visible = true;
            textBox4.Visible = true;
            textBox5.Visible = true;
            textBox6.Visible = true;
            textBox7.Visible = true;
            textBox8.Visible = true;
            textBox9.Visible = true;

            rbtnOYes.Enabled = false;
            rbtnONo.Checked = true;

            Common.ityp = 1;
        }

        /// <summary>
        /// This method checks whether the user has opted to use default ozone layer values.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rbtnOYes_CheckedChanged(object sender, EventArgs e)
        {
            lblOzone.Visible = false;
            txtOzone.Visible = false;
        }

        /// <summary>
        /// This method checks whether the user has opted to enter their own ozone layer value.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rbtnONo_CheckedChanged(object sender, EventArgs e)
        {
            lblOzone.Visible = true;
            txtOzone.Visible = true;
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox1, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox2_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox2, "");
        }

        private void textBox3_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox3, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox4_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox4, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox5_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox5, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox6_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox6, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox7_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox7, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox8_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox8, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox9_Validated(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidDegrees(textBox1.Text, out errorMessage))
            {
                e.Cancel = true;

                this.errorProvider1.SetError(textBox1, errorMessage);
            }            
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox2_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidMinutes(textBox2.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox2, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox3_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidSeconds(textBox3.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox3, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox4_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidDegrees(textBox4.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox4, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox5_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidMinutes(textBox5.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox5, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox6_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidSeconds(textBox6.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox6, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox7_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidDegrees(textBox7.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox7, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox8_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidMinutes(textBox8.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox8, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox9_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidSeconds(textBox9.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(textBox9, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtLat_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(txtLat, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtLat_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidLatitude(txtLat.Text, out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(txtLat, errorMessage);
            }
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void gbtnSeasons_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError(gbtnSeasons, "");
        }

        /// <summary>
        /// Validation method.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void gbtnSeasons_Validating(object sender, CancelEventArgs e)
        {
            string errorMessage;
            if (!ValidSeasons(out errorMessage))
            {
                e.Cancel = true;
                this.errorProvider1.SetError(gbtnSeasons, errorMessage);
            }
        }

        /// <summary>
        /// This method performs time-of-day calculations.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnToD_Click(object sender, EventArgs e)
        {

            if (!ValidateFields())
            {
                MessageBox.Show("There are invalid entries: check the textboxes marked with an exclamation point! Otherwise click Cancel to exit without saving any changes.");
                return;
            }

            update_Values();

            DataTable dtday = new DataTable();
            DataTable dtKL = new DataTable();
            Depend dp = new Depend();
            string errorMsg = "";
            dp.CalculatePhotolysisRatesHalfLivesTDay(out dtday, out dtKL, out errorMsg);

            // If an error message was returned, display it and return control to the Windows 
            // form.
            if (errorMsg != "")
            {
                MessageBox.Show(errorMsg);
                return;
            }

            TodForm tod = new TodForm(dtday, dtKL);
            tod.ShowDialog();
        }

        private void rbtnKlambdaYes_CheckedChanged(object sender, EventArgs e)
        {
            Common.ikalam = 1;
        }

        private void rbtnKlambdaNo_CheckedChanged(object sender, EventArgs e)
        {
            Common.ikalam = 0;
        }

        /// <summary>
        /// This methods handles the plotting of water and contaminant absorption coefficients.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnPlotAbsorptions_Click(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            DataTable dtData = new DataTable();
            DataRow dr1 = null;

            // Get selected absorptions.
            string itemAbs = cmbAbsorptions.SelectedItem.ToString();
            string xAxis = Common.wavelengthName;
            string absColumn = "";
            string yAxis = "";
            string contaminant = Common.contaminantType.Trim() + " " + Common.contaminantUnits.Trim();

            if (itemAbs.Equals("Water Absorption Coefficients"))
            {
                absColumn = Common.waterNameUnits;
                yAxis = Common.bodyWaterName + " Absorption Coefficients (m\x207B\x00B9)";
            }
            else
            {
                absColumn = contaminant;
                yAxis = contaminant;
            }

            // Add columns to the table that will hold the data to be plotted.
            dtData.Columns.Add(xAxis);
            dtData.Columns.Add(yAxis);

            // Get the data stored in the program.
            Common.Listing(out dt);

            // Build the dtData table with the data to be plotted.
            foreach (DataRow rows in dt.Rows)
            {
                dr1 = dtData.NewRow();
                dr1[xAxis] = rows[xAxis].ToString().Trim();
                dr1[yAxis] = rows[absColumn].ToString().Trim();
                dtData.Rows.Add(dr1);
            }

            // Plot the data.
            FormPlotAbsorptions abs = new FormPlotAbsorptions();
            abs.setTable(dtData, xAxis, yAxis);
            abs.ShowDialog();
        }

        private void rbtnYesDP_CheckedChanged(object sender, EventArgs e)
        {
            lblDeltaz.Visible = true;
            txtDeltaz.Visible = true;
            Common.useDeltaz = true;
        }

        private void rbtnNoDP_CheckedChanged(object sender, EventArgs e)
        {
            lblDeltaz.Visible = false;
            txtDeltaz.Visible = false;
            Common.useDeltaz = false;
        }

        private void FormChangeParameters_FormClosing(object sender, FormClosingEventArgs e)
        {
            // In case windows is trying to shut down, don't hold the process up
            if (e.CloseReason == CloseReason.WindowsShutDown) return;

            //  Check whether the Cancel and Save and Close buttons have been clicked.
            if (buttonCancelWasClicked == false && buttonSaveAndCloseWasClicked == false)
            {
                DialogResult dlg = MessageBox.Show(this, "Warning! No changes will be saved. Do you still want to close this window?", "" , MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dlg == DialogResult.No)
                {
                    e.Cancel = true;
                    return;
                }
            }
            e.Cancel = false;
                
        }
       
    }
}
