﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Globalization;


namespace GCSOLAR
{
    public partial class FormHelp : Form
    {
        public FormHelp()
        {
            InitializeComponent();
        }

        private void FormHelp_Load(object sender, EventArgs e)
        {
            double[] wave = new double[46] { 280.0, 282.5, 285.0, 287.5, 290.0, 292.5, 295.0,      
                                             297.5, 300.0, 302.5, 305.0, 307.5, 310.0, 312.5, 
                                             315.0, 317.5, 320.0, 323.1, 330.0, 340.0, 350.0, 
                                             360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 
                                             430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 
                                             500.0, 525.0, 550.0, 575.0, 600.0, 625.0, 650.0, 
                                             675.0, 700.0, 750.0, 800.0 };

            double[] eppest = new double[46] { 2200.0, 2020.0, 1530.0, 642.0, 271.0, 102.0, 28.0,  
                                               11.1, 4.67, 1.9, 1.1, 0.8, 0.53, 0.33, 0.27, 0.16, 
                                               0.1, 0.06, 0.02, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                               0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                               0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                               0.0, 0.0, 0.0 };

            double[] abwat = new double[46] { 0.00120, 0.00113, 0.00106, 0.00099, 0.00093, 0.00085,
                                             0.00077, 0.00069, 0.00061, 0.00057, 0.00053, 0.00049, 
                                             0.00045, 0.00043, 0.00041, 0.00039, 0.00037, 0.00035,   
                                             0.00029, 0.00024, 0.00020, 0.00016, 0.00013, .000096,  
                                             0.000083, 0.000074, 0.000070, 0.000066, 0.000062, 0.000062,   
                                             0.000062, 0.000068, 0.000068, 0.000076, 0.000085, 0.00012, 
                                             0.00021, 0.00028, 0.00041, 0.00100, 0.00140, 0.00150,  
                                             0.00190, 0.00280, 0.01000, 0.00890 };

            DataTable dt = new DataTable();
            DataRow dr1 = null;
            dt.Columns.Add("Wavelength (nm)");
            dt.Columns.Add("Water Absorption Coefficients (m**-1)");
            dt.Columns.Add(Common.contaminantType.Trim() + " Absorption Coefficients (L/(mole cm))");

            int minwav = Common.minwav;
            int maxwav = Common.maxwav;


            for (int i = minwav; i <= maxwav; i++)
            {
                dr1 = dt.NewRow();
                dr1["Wavelength (nm)"] = wave[i - 1].ToString("F2", CultureInfo.InvariantCulture);
                // Multiply water absorption coefficients by 100 to convert units from
                // cm^-1 to m^-1.
                double absorpWater = abwat[i - 1] * 100.0;
                dr1["Water Absorption Coefficients (m**-1)"] = absorpWater.ToString("F6", CultureInfo.InvariantCulture);
                dr1[Common.contaminantType.Trim() + " Absorption Coefficients (L/(mole cm))"] = eppest[i - 1].ToString("F6", CultureInfo.InvariantCulture);
                dt.Rows.Add(dr1);
            }

            dataGridView1.DataSource = dt;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
