﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;

namespace GCSOLAR
{
    public partial class HomeForm : Form
    {
        public HomeForm()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                ListForm listForm = new ListForm();
                listForm.listChemicalInformation();
                listForm.Show();
            }
            else if (radioButton2.Checked == true)
            {
                
                FormChangeParameters changeForm = new FormChangeParameters();
                changeForm.WindowState = FormWindowState.Maximized;
                changeForm.Show();
            }
            else if (radioButton3.Checked == true)
            {
                DataTable dtday = new DataTable();
                DataTable dtKL = new DataTable();
                Depend dp = new Depend();
                string errorMsg = "";
                dp.CalculatePhotolysisRatesHalfLivesTDay(out dtday, out dtKL, out errorMsg);

                // If an error message was returned, display it and return control to the Windows 
                // form.
                if (errorMsg != "")  
                {
                    MessageBox.Show(errorMsg);
                    return;
                }

                TodForm todForm = new TodForm(dtday, dtKL);
                todForm.ShowDialog();
            }
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void HomeForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = false;
        }

        /// <summary>
        /// This method opens the GCSolar's User Guide when the user clicks on the link located on the 
        /// upper right corner the opening form.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            // Specify that the link was visited.
            this.linkLabel1.LinkVisited = true;

            // Navigate to a URL.
            try
            {
                Process.Start("GCSolar.NET User's Manual.pdf");
            }
            catch(Exception ex)
            {
                MessageBox.Show("Exception found: " + ex);
            }
        }

     
    }
}
