﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;

namespace GCSOLAR
{
    public class Vis
    {
        /// <summary>
        /// Routine for producing solar intensity tables in the range of 390 - 800 nanometers.
        /// </summary>
        /// <returns></returns>
        public DataTable GenerateTableSolarIrradiance()
        {
            double[] ozoneAmount = new double[6] { 0.24, 0.28, 0.32, 0.36, 0.40, 0.44 };  // Units are in cm.  This will become a web
                                                                                          // service at some point in the near future.

            double[] solarAltitude = new double[10] { 5.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0 };

            double[] waveLength = Common.getWave();

            double[] SN = new double[22]; 
            double[] H = new double[22];
            string errorMsg = "";
            int llm24;
            
            DataTable dt = new DataTable();
            DataRow dr1 = null;
            dt.Columns.Add("Ozone Amount");
            dt.Columns.Add("Solar Altitude");
            dt.Columns.Add("Wavelength");
            dt.Columns.Add("H");
            dt.Columns.Add("SN");

            for (int k = 0; k < 6; k++)
            {
                for (int j = 0; j < 10; j++)
                {
                    for (int i = 25; i <= 46; i++)
                    {
                        llm24 = i - 24;
                        Common.tslam(ozoneAmount[k], solarAltitude[j], waveLength[i-1], out H[llm24-1], out SN[llm24-1], out errorMsg);
                        dr1 = dt.NewRow();
                        dr1["Ozone Amount"] = ozoneAmount[k];
                        dr1["Solar Altitude"] = solarAltitude[j];
                        dr1["Wavelength"] = waveLength[i-1];
                        dr1["H"] = H[llm24 - 1];
                        dr1["SN"] = SN[llm24 - 1];
                        dt.Rows.Add(dr1);
                    }
                }
            }

            return dt;
        }
    }
}
